Whamcloud - gitweb
landing b_cmobd_merge on HEAD
[fs/lustre-release.git] / lustre / tests / sanityN.sh
index 581c514..974fdbb 100644 (file)
@@ -3,7 +3,11 @@
 set -e
 
 ONLY=${ONLY:-"$*"}
-ALWAYS_EXCEPT=${ALWAYS_EXCEPT:-"8"} # bug 1557
+# bug number for skipped test: 1768
+ALWAYS_EXCEPT=${ALWAYS_EXCEPT:-"4   14b"}
+# UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
+
+[ "$ALWAYS_EXCEPT$EXCEPT" ] && echo "Skipping tests: $ALWAYS_EXCEPT $EXCEPT"
 
 SRCDIR=`dirname $0`
 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
@@ -54,7 +58,9 @@ run_one() {
                $START
        fi
        log "== test $1: $2"
-       test_$1 || error "test_$1: $?"
+       export TESTNAME=test_$1
+       test_$1 || error "test_$1: exit with rc=$?"
+       unset TESTNAME
        pass
        cd $SAVE_PWD
        $CLEAN
@@ -82,24 +88,30 @@ run_test() {
        fi
 }
 
+[ "$SANITYLOG" ] && rm -f $SANITYLOG || true
+
 error () {
-       log "FAIL: $@"
-       exit 1
+       log "FAIL: $TESTNAME $@"
+       if [ "$SANITYLOG" ]; then
+               echo "FAIL: $TESTNAME $@" >> $SANITYLOG
+       else
+               exit 1
+       fi
 }
 
 pass() {
        echo PASS
 }
 
-MOUNT1=`mount| awk '/ lustre/ { print $3 }'| head -1`
-MOUNT2=`mount| awk '/ lustre/ { print $3 }'| tail -1`
+export MOUNT1=`mount| awk '/ lustre/ { print $3 }'| head -n 1`
+export MOUNT2=`mount| awk '/ lustre/ { print $3 }'| tail -n 1`
 [ -z "$MOUNT1" ] && error "NAME=$NAME not mounted once"
 [ "$MOUNT1" = "$MOUNT2" ] && error "NAME=$NAME not mounted twice"
 [ `mount| awk '/ lustre/ { print $3 }'| wc -l` -ne 2 ] && \
        error "NAME=$NAME mounted more than twice"
 
-DIR1=${DIR1:-$MOUNT1}
-DIR2=${DIR2:-$MOUNT2}
+export DIR1=${DIR1:-$MOUNT1}
+export DIR2=${DIR2:-$MOUNT2}
 [ -z "`echo $DIR1 | grep $MOUNT1`" ] && echo "$DIR1 not in $MOUNT1" && exit 96
 [ -z "`echo $DIR2 | grep $MOUNT2`" ] && echo "$DIR2 not in $MOUNT2" && exit 95
 
@@ -156,7 +168,7 @@ test_2d() {
        chmod 755 $DIR1
        $CHECKSTAT -t dir -p 0755 $DIR2 || error
 }
-run_test 2c "check cached attribute updates on 2 mtpt's root ==="
+run_test 2d "check cached attribute updates on 2 mtpt's root ==="
 
 test_3() {
        ( cd $DIR1 ; ln -s this/is/good lnk )
@@ -202,11 +214,11 @@ test_9() {
                [ "$MTPT" -eq 1 ] && MTPT=2 || MTPT=1
        done
        [ "`cat $DIR1/f9`" = "abcdefghijkl" ] || \
-               error "`od -a $DIR1/f10` != abcdefghijkl"
+               error "`od -a $DIR1/f9` != abcdefghijkl"
 }
 run_test 9 "append of file with sub-page size on multiple mounts"
 
-test_10() {
+test_10a() {
        MTPT=1
        OFFSET=0
        > $DIR2/f10
@@ -219,12 +231,27 @@ test_10() {
        [ "`cat $DIR1/f10`" = "abcdefghijkl" ] || \
                error "`od -a $DIR1/f10` != abcdefghijkl"
 }
-run_test 10 "write of file with sub-page size on multiple mounts "
+run_test 10a "write of file with sub-page size on multiple mounts "
+
+test_10b() {
+       yes "R" | dd of=$DIR1/f10b bs=3k count=1 || error "dd $DIR1"
+
+       truncate $DIR1/f10b 4096 || error "truncate 4096"
+
+       dd if=$DIR2/f10b of=$TMP/f10b-lustre bs=4k count=1 || error "dd $DIR2"
+
+       # create a test file locally to compare
+       yes "R" | dd of=$TMP/f10b bs=3k count=1 || error "dd random"
+       truncate $TMP/f10b 4096 || error "truncate 4096"
+       cmp $TMP/f10b $TMP/f10b-lustre || error "file miscompare"
+}
+run_test 10b "write of file with sub-page size on multiple mounts "
 
 test_11() {
        mkdir $DIR1/d11
        multiop $DIR1/d11/f O_c &
        MULTIPID=$!
+       usleep 200
        cp -p /bin/ls $DIR1/d11/f
        $DIR2/d11/f
        RC=$?
@@ -239,6 +266,70 @@ test_12() {
 }
 run_test 12 "test lock ordering (link, stat, unlink) ==========="
 
+test_13() {    # bug 2451 - directory coherency
+       rm -rf $DIR1/d13
+       mkdir $DIR1/d13 || error
+       cd $DIR1/d13 || error
+       ls
+       ( touch $DIR1/d13/f13 ) # needs to be a separate shell
+       ls
+       rm -f $DIR2/d13/f13 || error
+       ls 2>&1 | grep f13 && error "f13 shouldn't return an error (1)" || true
+       # need to run it twice
+       ( touch $DIR1/d13/f13 ) # needs to be a separate shell
+       ls
+       rm -f $DIR2/d13/f13 || error
+       ls 2>&1 | grep f13 && error "f13 shouldn't return an error (2)" || true
+}
+run_test 13 "test directory page revocation ===================="
+
+test_14() {
+       mkdir $DIR1/d14
+       cp -p /bin/ls $DIR1/d14/ls
+       exec 100>> $DIR1/d14/ls
+       $DIR2/d14/ls && error || true
+       exec 100<&-
+}
+run_test 14 "execution of file opened for write should return -ETXTBSY=="
+
+test_14a() {
+        mkdir -p $DIR1/d14
+       cp -p `which multiop` $DIR1/d14/multiop
+        $DIR1/d14/multiop $TMP/test14.junk O_c &
+        MULTIPID=$!
+        sleep 1
+        multiop $DIR2/d14/multiop Oc && error "expected error, got success"
+        kill -USR1 $MULTIPID || return 2
+        wait $MULTIPID || return 3
+}
+run_test 14a "open(RDWR) of file being executed should return -ETXTBSY"
+
+test_14b() {
+        mkdir -p $DIR1/d14
+       cp -p `which multiop` $DIR1/d14/multiop
+        $DIR1/d14/multiop $TMP/test14.junk O_c &
+        MULTIPID=$!
+        sleep 1
+        truncate $DIR2/d14/multiop 0 && error "expected error, got success"
+        kill -USR1 $MULTIPID || return 2
+        wait $MULTIPID || return 3
+}
+run_test 14b "truncate of file being executed should return -ETXTBSY"
+
+test_15() {    # bug 974 - ENOSPC
+       echo $PATH
+       sh oos2.sh $MOUNT1 $MOUNT2
+}
+run_test 15 "test out-of-space with multiple writers ==========="
+
+test_16() {
+       ./fsx -R -W -c 50 -p 100 -N 2500 \
+               $MOUNT1/fsxfile $MOUNT2/fsxfile
+}
+run_test 16 "2500 iterations of dual-mount fsx ================="
+
 log "cleanup: ======================================================"
 rm -rf $DIR1/[df][0-9]* $DIR1/lnk || true
+
 echo '=========================== finished ==============================='
+[ -f "$SANITYLOG" ] && cat $SANITYLOG && exit 1 || true